<?php
// Credit Louviaux Jean-Marc 2015
define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);
include('../config/config_layout.php');

if (isset($_COOKIE['user_lang'])) {
    $user_lang = $_COOKIE['user_lang'];
} else {
    $user_lang = 'English';
}
include('../languages/' . $user_lang . '.php');

for ($i = 1; $i <= $NUMMETER; $i++) {
    include("../config/config_met$i.php");
    $val_first24[$i] = null;
    $val_last24[$i]  = null;
}
$dir    = '../data/csv/';
$output = array();
$output = glob($dir . '*.csv');
sort($output);
$cnt = count($output);

$file       = file($output[$cnt - 1]);
$contalines = count($file);
$startline  = 0;

// Yesterday
$yesterday = date('Ymd', time() - 60 * 60 * 24);
if ($contalines < 290 && file_exists($dir . "$yesterday.csv")) {
    $file = file($dir . "$yesterday.csv");
    
    $contalines2 = count($file) - 1;
    $startline   = $contalines2 - 290 + $contalines; // (24*12)+2 hearder
    if ($startline < 1) {
        $startline = 2;
    }
    
    for ($line_num = $startline; $line_num <= $contalines2; $line_num++) {
        $pastline_num = $line_num - 1;
        $linearray    = preg_split("/,/", $file[$pastline_num]);
        for ($i = 1; $i <= $NUMMETER; $i++) {
            if (empty($val_first24[$i]) && isset($linearray[$i])) {
                $val_first24[$i] = trim($linearray[$i]);
            }
        }
    }
}

// Today
$year  = substr($output[$cnt - 1], -12, 4);
$month = substr($output[$cnt - 1], -8, 2);
$day   = substr($output[$cnt - 1], -6, 2);
$file  = file($output[$cnt - 1]);

$prevlinearray = preg_split("/,/", $file[$contalines - 2]);

$fileUTCdate = strtotime(date("$year$month$day"));
$todayUTC    = strtotime(date('Ymd'));

for ($line_num = 2; $line_num < $contalines; $line_num++) {
    $linearray = preg_split("/,/", $file[$line_num]);
    for ($i = 1; $i <= $NUMMETER; $i++) {
		if (empty($val_first24[$i]) && isset($linearray[$i])) {
        $val_first24[$i] = trim($linearray[$i]);
        }
        if (isset($linearray[$i])) {
            $val_last24[$i] = trim($linearray[$i]);
        }
    }
}
$hour   = substr($linearray[0], 0, 2);
$minute = substr($linearray[0], 3, 2);

if ($line_num == $contalines && $hour == '00' && $minute == '00') { // Tomorow midnight
    $data[0] = strtotime(($year . '-' . $month . '-' . $day)) + 86400;
} else {
    $data[0] = strtotime($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $minute);
}
$data[0] *= 1000;

if ($fileUTCdate == $todayUTC) {
    $title = '';
} elseif ($fileUTCdate == strtotime(date('Ymd', strtotime('-1 day')))) {
    $title = stripslashes("$lgYESTERDAYTITLE");
} else {
    $dday  = date($DATEFORMAT, $fileUTCdate);
    $title = stripslashes("$dday");
}

$graphlist = array();

for ($i = 1; $i <= $NUMMETER; $i++) {
    settype($val_first24[$i], 'float');
    settype($val_last24[$i], 'float');
    
    if (${'TYPE' . $i} != 'Sensor') { // Meter
        if ($val_first24[$i] <= $val_last24[$i]) {
            $val_last24[$i] -= $val_first24[$i];
        } else { // counter pass over
            $val_last24[$i] += ${'PASSO' . $i} - $val_first24[$i];
        }
    }
    if (${'PRICE' . $i} > 0) {
        $money[$i] = number_format(($val_last24[$i] * ${'PRICE' . $i}), 2, $DPOINT, $THSEP);
        $money[$i] = '/' . $money[$i] . $CURS;
    } else {
        $money[$i] = '';
    }
    if (${'TYPE' . $i} == 'Elect') {
        if ($val_last24[$i] <= 1000) {
            $prefix[$i]     = '';
            $val_last24[$i] = number_format($val_last24[$i], 0, $DPOINT, $THSEP);
        } elseif ($val_last24[$i] > 1000000) {
            $val_last24[$i] /= 1000000;
            $prefix[$i]     = 'M';
            $val_last24[$i] = number_format($val_last24[$i], 2, $DPOINT, $THSEP);
        } elseif ($val_last24[$i] > 1000) {
            $val_last24[$i] /= 1000;
            $prefix[$i]     = 'k';
            $val_last24[$i] = number_format($val_last24[$i], 2, $DPOINT, $THSEP);
        }
    } else {
        $val_last24[$i] = number_format($val_last24[$i], ${'PRECI' . $i}, $DPOINT, $THSEP);
        $prefix[$i]     = '';
    }
    
    $graphnum = ${'GRAPH_MET' . $i};
    if (!in_array($graphnum, $graphlist)) {
        $graphlist[]      = (int) $graphnum;
        $yaxis[$graphnum] = (int) 0;
        
        $titlelist[$graphnum] = $title . ' ' . ${'METNAME' . $i} . " ($val_last24[$i] $prefix[$i]${'UNIT'.$i}$money[$i]) ";
    } else {
        $titlelist[$graphnum] .= '- ' . ${'METNAME' . $i} . " ($val_last24[$i] $prefix[$i]${'UNIT'.$i}$money[$i]) ";
    }
    
    $val_first = trim($prevlinearray[$i]);
    $val_last  = trim($linearray[$i]);
    
    if (!empty($val_first) && !empty($val_last)) {
        settype($val_first, 'float');
        settype($val_last, 'float');
        if (${'TYPE' . $i} != 'Sensor') { // Meter    
            if ($val_first <= $val_last) {
                $val_last -= $val_first;
            } else { // counter just pass over
                $val_last += ${'PASSO' . $i} - $val_first;
            }
        }
    } else {
        $val_last = 0;
    }
	
	$val_last = round($val_last, ${'PRECI' . $i});
    $data[$i] = $val_last;
}

sort($graphlist);

$cnt = count($graphlist);
for ($j = 0; $j < $cnt; $j++) {
    $data[$i + $j] = $titlelist[$graphlist[$j]];
}

header("Content-type: text/json");
echo json_encode($data);
?>