<?php
// Credit Louviaux Jean-Marc 2015
define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);

if (isset($_COOKIE['user_lang'])) {
    $user_lang = $_COOKIE['user_lang'];
} else {
    $user_lang = 'English';
}

include('../languages/' . $user_lang . '.php');

if (!empty($_GET['meter'])) {
    $meter = $_GET['meter'];
}

$metnum = substr($meter, 0, 1);
include("../config/config_met$metnum.php");

$dir       = '../data/meters/';
$whichyear = substr($meter, -8, 4);

if (file_exists($dir . $meter)) {
    $thefile    = file($dir . $meter);
    $contalines = count($thefile);
    for ($line_num = 0; $line_num < $contalines; $line_num++) {
        $array                   = preg_split("/,/", $thefile[$line_num]);
        $month                   = substr($array[0], 0, 2);
        $day                     = substr($array[0], 2, 2);
        $date1                   = strtotime($whichyear . '-' . $month . '-' . $day);
        $month                   = (int) ($month - 1);
        $day                     = (int) ($day);
        $conso_day[$month][$day] = (float) ($array[1]);
        if (${'TYPE' . $metnum} == 'Elect') {
            $conso_day[$month][$day] /= 1000;
        }
        $subdate[$month][$day] = $date1 * 1000;
    } // end of looping through the file
}

if ($whichyear == date('Y')) { // Add today conso
    $dir    = '../data/csv';
    $output = glob($dir . '/*.csv');
    rsort($output);
    if (isset($output[0])) {
        $file       = file($output[0]);
        $month      = substr($output[0], -8, 2);
        $day        = substr($output[0], -6, 2);
        $contalines = count($file);
        $prevarray  = preg_split('/,/', $file[1]);
        $linearray  = preg_split('/,/', $file[$contalines - 1]);
        $met        = substr($meter, 0, 1);
        $val_first  = $prevarray[$met];
        $val_last   = $linearray[$met];
        settype($val_first, 'float');
        settype($val_last, 'float');
        
        if ($val_first <= $val_last) {
            $val_last -= $val_first;
        } else { // counter pass over
            $val_last += ${'PASSO' . $metnum} - $val_first;
        }
        
        $date1                   = strtotime($whichyear . '-' . $month . '-' . $day);
        $month                   = (int) ($month - 1);
        $day                     = (int) ($day);
        $conso_day[$month][$day] = (float) ($val_last);
        if (${'TYPE' . $metnum} == 'Elect') {
            $conso_day[$month][$day] /= 1000;
        }
        $subdate[$month][$day] = $date1 * 1000;
    }
} // end of today conso

$stmonth = 1;

for ($h = 0; $h < 12; $h++) { // Fill blanks dates
    $daythatm = cal_days_in_month(CAL_GREGORIAN, $stmonth, $whichyear);
    if (isset($conso_day[$h])) {
        $month_len = count($conso_day[$h]);
    } else {
        $month_len = 0;
    }
    if ($month_len < $daythatm) {
        for ($i = 1; $i <= $daythatm; $i++)
            if (!isset($conso_day[$h][$i])) {
                $date1             = strtotime($whichyear . '-' . $stmonth . '-' . $i);
                $subdate[$h][$i]   = $date1 * 1000;
                $conso_day[$h][$i] = 0;
            }
    }
    $stmonth++;
}

$conso_y = 0;
for ($h = 0; $h < 12; $h++) {
    if (!isset($conso_m[$h])) {
        $conso_m[$h] = 0;
    }
    $conso_m[$h] += array_sum($conso_day[$h]); // Month conso
    
    if (${'PRICE' . $metnum} > 0) {
        if (${'TYPE' . $metnum} == 'Elect') {
            $money_m[$h] = number_format(($conso_m[$h] * 1000 * ${'PRICE' . $metnum}), 1, $DPOINT, $THSEP);
        } else {
            $money_m[$h] = number_format(($conso_m[$h] * ${'PRICE' . $metnum}), 1, $DPOINT, $THSEP);
        }
        
        $money_m[$h] = "/$money_m[$h]$CURS";
    } else {
        $money_m[$h] = '';
    }
    $conso_y += $conso_m[$h]; // Year conso  	
}


for ($h = 0; $h < 12; $h++) {
    $yaxis_m[$h] = $conso_m[$h];
    if (${'TYPE' . $metnum} == 'Elect') {
        $conso_m[$h] = number_format($conso_m[$h], 1, $DPOINT, $THSEP);
        $conso_m[$h] .= "k";
    } else {
        $conso_m[$h] = number_format($conso_m[$h], ${'PRECI' . $metnum}, $DPOINT, $THSEP);
    }
    $conso_m[$h] .= "${'UNIT'.$metnum}";
}

if (${'PRICE' . $metnum} > 0) {
    if (${'TYPE' . $metnum} == 'Elect') {
        $money_y = number_format(($conso_y * 1000 * ${'PRICE' . $metnum}), 0, $DPOINT, $THSEP);
    } else {
        $money_y = number_format(($conso_y * ${'PRICE' . $metnum}), 0, $DPOINT, $THSEP);
    }
    $money_y = "/$money_y $CURS";
} else {
    $money_y = '';
}

if (${'TYPE' . $metnum} == 'Elect') {
    $conso_y = number_format($conso_y, 0, $DPOINT, $THSEP);
    $conso_y .= " k${'UNIT'.$metnum}";
} else {
    $conso_y = number_format($conso_y, ${'PRECI' . $metnum}, $DPOINT, $THSEP);
    $conso_y .= " ${'UNIT'.$metnum}";
}

$i = 1;
$m = 0;
for ($h = 0; $h < 12; $h++) { // Rearrange 'em all
    $cnt      = count($subdate[$h]);
    $k        = 0;
    $date1    = strtotime($whichyear . '-' . $i . '-01');
    $fstd[$h] = $date1 * 1000;
    
    for ($j = 1; $j <= $cnt; $j++) {
        $drilldata[$k] = array(
            $subdate[$h][$j],
            $conso_day[$h][$j]
        );
        $k++;
    }
    
    $drilldown[$h] = array(
        'color' => "#${'COLOR'.$metnum}",
        'xAxis' => 1,
        'data' => $drilldata,
        'conso_m' => "$conso_m[$h]",
        'money_m' => "$money_m[$h]",
        'month' => $m
    );
    
    $drilldata = array();
    $m++;
    $i++;
}

for ($h = 0; $h < 12; $h++) {
    $datareturn[$h] = array(
        'x' => $fstd[$h],
        'y' => $yaxis_m[$h],
        'color' => "#${'COLOR'.$metnum}",
        'drilldown' => $drilldown[$h]
    );
}

$jsonreturn = array(
    'data' => $datareturn,
    'conso_y' => $conso_y,
    'money_y' => $money_y
);

header("Content-type: text/json");
echo json_encode($jsonreturn);
?>
